(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('jo-util')) :
  typeof define === 'function' && define.amd ? define(['jo-util'], factory) :
  (global = global || self, global.joDragin = factory(global.joUtil));
}(this, (function (joUtil) { 'use strict';

  joUtil = joUtil && Object.prototype.hasOwnProperty.call(joUtil, 'default') ? joUtil['default'] : joUtil;

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  var noop = joUtil.noop,
      addEvent = joUtil.addEvent,
      addClass = joUtil.addClass,
      parseHTML = joUtil.parseHTML,
      isFunction = joUtil.isFunction,
      getOffset = joUtil.getOffset,
      _getEls = joUtil.getEls;

  var Dragin = /*#__PURE__*/function () {
    function Dragin(elem, options) {
      _classCallCheck(this, Dragin);

      this.elem = elem;
      this.mirror = null;
      this.setOptions(options);

      if (options.isLaunch !== false) {
        this.setup();
      }
    }

    _createClass(Dragin, [{
      key: "setOptions",
      // 设置配置
      value: function setOptions(_ref) {
        var _ref$clone = _ref.clone,
            clone = _ref$clone === void 0 ? null : _ref$clone,
            _ref$dir = _ref.dir,
            dir = _ref$dir === void 0 ? 'hor,ver' : _ref$dir,
            _ref$limitX = _ref.limitX,
            limitX = _ref$limitX === void 0 ? [] : _ref$limitX,
            _ref$limitY = _ref.limitY,
            limitY = _ref$limitY === void 0 ? [] : _ref$limitY,
            _ref$start = _ref.start,
            start = _ref$start === void 0 ? noop : _ref$start,
            _ref$move = _ref.move,
            move = _ref$move === void 0 ? noop : _ref$move,
            _ref$end = _ref.end,
            end = _ref$end === void 0 ? noop : _ref$end;
        this.clone = clone;
        var temp = dir.split(',');
        this.hasHor = temp.indexOf('hor') > -1;
        this.hasVer = temp.indexOf('ver') > -1;
        this.limitX = limitX; // 限制X的范围

        this.limitY = limitY; // 限制Y的范围

        this.callback = {
          start: start,
          move: move,
          end: end
        };
      } // 启动

    }, {
      key: "setup",
      value: function setup() {
        var _this = this;

        // this.elem.classList.add('dragin');
        // addClass(this.elem, 'dragin-source');
        addEvent(this.elem, 'mousedown', function (e) {
          _this.start(e);

          e.preventDefault();
        }, false);
      }
    }, {
      key: "create",
      value: function create() {
        if (this.clone === true) {
          this.mirror = this.elem.cloneNode(true);
        } else if (isFunction(this.clone)) {
          this.mirror = parseHTML(this.clone());
        } else {
          this.mirror = parseHTML(this.clone);
        }

        this.mirror.style.left = this.cx + 'px';
        this.mirror.style.top = this.cy + 'px';
        addClass(this.mirror, 'dragin-mirror');
        document.body.appendChild(this.mirror);
      }
    }, {
      key: "remove",
      value: function remove() {
        if (this.mirror) {
          document.body.removeChild(this.mirror);
          this.mirror = null;
        }
      }
    }, {
      key: "start",
      value: function start(e) {
        var _this2 = this;

        var point = getOffset(this.elem); // this.elem.style.ev

        this.cx = point.x;
        this.cy = point.y; // 偏差值

        this.disX = this.cx - e.clientX;
        this.disY = this.cy - e.clientY;
        this.unbind = addEvent(document, 'mousemove', function (e) {
          _this2.move(e);

          e.preventDefault();
        });
        this.unbind2 = addEvent(document, 'mouseup', function () {
          _this2.end();
        });
        this.callback.start.call(this, this.cx, this.cy);
      }
    }, {
      key: "move",
      value: function move(e) {
        if (!this.mirror) {
          if (this.clone) {
            this.create();
          } else {
            this.mirror = this.elem;
          }
        }

        this.cx = e.clientX + this.disX;
        this.cy = e.clientY + this.disY; // 限制移动

        if (this.cx < this.limitX[0]) {
          this.cx = this.limitX[0];
        } else if (this.cx > this.limitX[1] - this.mirror.offsetWidth) {
          this.cx = this.limitX[1] - this.mirror.offsetWidth;
        }

        if (this.cy < this.limitY[0]) {
          this.cy = this.limitY[0];
        } else if (this.cy > this.limitY[1] - this.mirror.offsetHeight) {
          this.cy = this.limitY[1] - this.mirror.offsetHeight;
        }

        if (this.hasHor) {
          this.mirror.style.left = this.cx + 'px';
        } else {
          this.cx = this.mirror.offsetLeft;
        }

        if (this.hasVer) {
          this.mirror.style.top = this.cy + 'px';
        } else {
          this.cy = this.mirror.offsetTop;
        }

        this.callback.move.call(this, this.cx, this.cy);
      }
    }, {
      key: "end",
      value: function end() {
        if (this.clone) {
          this.remove();
        } // 释放事件


        this.unbind();
        this.unbind2();
        this.callback.end.call(this, this.cx, this.cy);
      }
    }], [{
      key: "getEls",
      value: function getEls() {
        return _getEls.apply(void 0, arguments);
      }
    }]);

    return Dragin;
  }();

  return Dragin;

})));
